"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImageTransformer = void 0;
const sharp_1 = __importDefault(require("sharp"));
class ImageTransformer {
    transform(image, options) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const transformedImage = (0, sharp_1.default)(image);
                yield transformedImage.resize(options.width, options.height, {
                    fit: 'cover',
                });
                if (options.format) {
                    yield transformedImage.toFormat(options.format, {
                        quality: 100,
                        progressive: true,
                    });
                }
                return yield transformedImage.toBuffer();
            }
            catch (err) {
                throw new Error(`An error occurred during transforming the image: ${err}`);
            }
        });
    }
}
exports.ImageTransformer = ImageTransformer;
