"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.uploadMiddleware = void 0;
const multer_1 = __importDefault(require("multer"));
const multer_2 = require("../multer");
function uploadMiddleware(options) {
    const _func = (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        if (req.file) {
            return res.status(200).json({
                response: req.file,
            });
        }
        return res.status(409).json({
            response: 'Invalid file format',
        });
    });
    return [(0, multer_1.default)((0, multer_2.multerConfig)(options.storage)).single('file'), _func];
}
exports.uploadMiddleware = uploadMiddleware;
