"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multerConfig = void 0;
const types_1 = require("./types");
function multerConfig(storage) {
    if (typeof storage.getMulterStorage !== 'function') {
        throw new Error("Method 'multerConfig' does not exist in the storage class used");
    }
    return {
        storage: storage.getMulterStorage(),
        fileFilter: (req, file, cb) => {
            const fileFormat = file.mimetype.split('/')[1];
            if (fileFormat in types_1.FormatEnum) {
                cb(null, true);
            }
            else {
                cb(new Error('Invalid file type.'));
            }
        },
    };
}
exports.multerConfig = multerConfig;
