/// <reference types="node" />
import { StorageEngine } from 'multer';
import { S3StorageOptions, Storage } from '../types';
declare class S3Storage implements Storage {
    private bucketName;
    private s3Client;
    constructor(options: S3StorageOptions);
    save(id: string, image: Buffer): Promise<boolean>;
    fetch(id: string): Promise<Buffer | undefined>;
    exists(id: string): Promise<boolean>;
    getMulterStorage(): StorageEngine;
}
export { S3Storage };
